#include "xtama_rensa.h"

int seek ( register int x ,register int y ,register int *tmprensa ,register int dir ,register int color )
{
  if ( map[x][y][player] != color || state[player][x][y] )
    return 0 ;
  
  state[player][x][y] |= dir ;
  (*tmprensa) ++ ;

  if ( !( state[player][x][y] & SEEK_LEFT ))
    {
      if ( x > 0 )
	seek( x - 1, y , tmprensa , SEEK_RIGHT , color ) ;
      state[player][x][y] |= SEEK_LEFT ;
    }
  
  if ( !( state[player][x][y] & SEEK_LOWER ))
    {
      if ( y < 11 )
	seek( x , y + 1 , tmprensa , SEEK_UPPER , color ) ;
      state[player][x][y] |= SEEK_LOWER ;
    }
  
  if ( !( state[player][x][y] & SEEK_RIGHT ))
    {
      if ( x < 5 )
	seek( x + 1 , y , tmprensa , SEEK_LEFT , color ) ;
      state[player][x][y] |= SEEK_RIGHT ;
    }
  
  if ( !( state[player][x][y] & SEEK_UPPER ))
    {
      if ( y > 0 )
	seek( x , y - 1 , tmprensa , SEEK_LOWER , color ) ;
      state[player][x][y] |= SEEK_UPPER ;
    }
  return * tmprensa ;
}

void tama_scan()
{
  register int i , j , ii , jj  , tmp_color ;
  int connection , tmp_rensa ,tmp_connection ; 
  static int store[2] = { 0 , 0 } ;

  connection = tmp_rensa = 0 ;
  
  Dairensa[player] ++ ;

  for ( i = 0 ; i < 13 ; i ++ )
    for ( j = 0 ; j < 6 ; j ++ )
      state[player][j][i] = statemask[player][j][i] = 0 ;
  
  for ( i = 0 ; i < 13 ; i ++ )
    for ( j = 0 ; j < 6 ; j ++ ) {
      tmp_color = map[j][i][player] ;
      if ( tmp_color && tmp_color < 6 && statemask[player][j][i] == 0 ) {
	tmp_connection = 0 ;
	
	if ( seek( j , i , &tmp_connection ,0 , tmp_color ) > erase ) {
	  for ( ii = 0 ; ii < 13 ; ii ++ )
	    for ( jj = 0 ; jj < 6 ; jj ++ ) {
	      if ( state[player][jj][ii] == 15 ) {
		statemask[player][jj][ii] = True ;
		tmp_rensa ++ ;
		connection += tmp_connection ;
	      }
	    }
	}
	for ( ii = 0 ; ii < 13 ; ii ++ )
	  for ( jj = 0 ; jj < 6 ; jj ++ )
	    state[player][jj][ii] =  0 ;
      }
    }
  if ( tmp_rensa ) {
    func[player] = FLUSH_INIT1 ;
    tama_score( connection * 7 * tmp_rensa + Dairensa[player] * 10 , player ) ;
    if ( Dairensa[player] > 1 ){
      if ( Dairensa[player] == 2 )
	okuritama[player] += store[player] ;
      okuritama[player] += tmp_rensa + 1 ;
    }
    else{
      store[player] = tmp_rensa ;
      DoCursor( HOLD , 0 , 0 , 0 , 0 , 0 , 0 );
    }
    if ( maxrensa < Dairensa[A] )
      maxrensa = Dairensa[A] ;
  }
  else {
    func[player] = IDLE ;
    lock[player] = False ;
    DoCursor( FREE , 0 , 0 , 0 , 0 , 0 , 0 );
    Dairensa[player] = 0 ;
    tmpokuri[player] = okuritama[player] ;
  }
  
  return ;
}

void tama_can( int canmode )
{
  int count = 0 ,i , j , sw ;
  
  static struct Tmap{
    int x ;
    int y ;
    int color ;
    int state ;
  } tamamap[100] ;
  
  if ( !canmode ) {
    DoCursor( HOLD , 0 , 0 , 0 , 0 , 0 , 0 );
    for ( j = 0 ; j < 6 ; j ++ ) {
      sw = False ;
      for ( i = 0 ; i < 24 ; i ++ ){
	if ( !sw )
	  if ( ! map[j][i][player] && map[j][i + 1][player] )
	    sw = True ;
	if ( sw && map[j][i][player] ) {
	  tamamap[count].x = j ;
	  tamamap[count].y = i ;
	  tamamap[count].color = map[j][i][player] ;
	  tamamap[count].state = True ;
	  count ++ ;
	  map[j][i ][player] = 0 ;
	  
	}
      }
    }
    sw = count ;
    while( sw ){
      sw = False ;
      for ( i = 0 ; i < count ; i ++ )
	if ( tamamap[i].state ){
	  sw = True ;
	  tamamap[i].state = tama_fall( tamamap[i].x , tamamap[i].y 
					, tamamap[i].color ) ;
	  tamamap[i].y -- ;
	}
    }
    if ( count )
      chmap = True ;
    func[player] = SCAN ;
    return ;
  }
  
  for ( j = 0 ; j < 6 ; j ++ ){
    if ( ! map[j][12][player] ) 
      for ( i = 13 ; i < 13 + canmode ; i ++ ){
	if ( map[j][i][player] ){
	  tamamap[count].x = j ;
	  tamamap[count].y = i ;
	  tamamap[count].color = map[j][i][player] ;
	  tamamap[count].state = True ;
	  count ++ ;
	  map[j][i][player] = 0 ;
	}
      }
    else
      for ( i = 13 ; i < 18 ; i ++ )
	map[j][i][player] = 0 ;
  }
  
  sw = True ;
  while( sw ){
    sw = False ;
    for ( i = 0 ; i < count ; i ++ )
      if ( tamamap[i].state ){
	sw = True ;
	tamamap[i].state = tama_fall( tamamap[i].x , tamamap[i].y 
				      , tamamap[i].color ) ;
	tamamap[i].y -- ;
      }
  }
  return ;
}
